<?php
/**************************************************************************
**  (c) Copyright 2002, Andromeda Technology & Automation
** This is free software; you can redistribute it and/or modify it under the
** terms of the GNU General Public License, see the file COPYING.
***************************************************************************/

require_once('configuration.class.php');

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : gnucomo_config
//  BASECLASS      : configuration
//  MEMBERS        : 
//  OPERATORS      :
//  METHODS        : Database - Obtain the database access string
//
//  DESCRIPTION    : Provides Gnucomo-specific configuration functions
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Nov 21, 2002
///////////////////////////////////////////////////////////////////////////
*/

class gnucomo_config extends configuration
{

   // Return the database access string.

   function Database($usr = "", $pw = "")
   {
      $access_string = "";

      $param = $this->find_parameter("database", "name");
      if ($param != "")
      {
         $access_string .= "dbname=" . $param;
      }

      if ($usr == "")
      {
         $param = $this->find_parameter("database", "user");
         if ($param != "")
         {
            $access_string .= " user=" . $param;
         }
      }
      else
      {
         $access_string .= " user=" . $usr;
      }

      if ($pw == "")
      {
         $param = $this->find_parameter("database", "password");
         if ($param != "")
         {
            $access_string .= " password=" . $param;
         }
      }
      else
      {
         $access_string .= " password=" . $pw;
      }

      $param = $this->find_parameter("database", "host");
      if ($param != "")
      {
         $access_string .= " host=" . $param;
      }

      $param = $this->find_parameter("database", "port");
      if ($param != "")
      {
         $access_string .= " port=" . $param;
      }
      return $access_string;
   }
};
?>
